package com.hfkj.dao;

import com.hfkj.entity.BsGasOrderReceipt;
import com.hfkj.entity.BsGasOrderReceiptExample.Criteria;
import com.hfkj.entity.BsGasOrderReceiptExample.Criterion;
import com.hfkj.entity.BsGasOrderReceiptExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsGasOrderReceiptSqlProvider {

    public String countByExample(BsGasOrderReceiptExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_gas_order_receipt");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsGasOrderReceiptExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_gas_order_receipt");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsGasOrderReceipt record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_gas_order_receipt");
        
        if (record.getApplyNo() != null) {
            sql.VALUES("apply_no", "#{applyNo,jdbcType=VARCHAR}");
        }
        
        if (record.getUserReceiptId() != null) {
            sql.VALUES("user_receipt_id", "#{userReceiptId,jdbcType=BIGINT}");
        }
        
        if (record.getCompanyName() != null) {
            sql.VALUES("company_name", "#{companyName,jdbcType=VARCHAR}");
        }
        
        if (record.getTaxNo() != null) {
            sql.VALUES("tax_no", "#{taxNo,jdbcType=VARCHAR}");
        }
        
        if (record.getContactsPhone() != null) {
            sql.VALUES("contacts_phone", "#{contactsPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getEmail() != null) {
            sql.VALUES("email", "#{email,jdbcType=VARCHAR}");
        }
        
        if (record.getAgentId() != null) {
            sql.VALUES("agent_id", "#{agentId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentName() != null) {
            sql.VALUES("agent_name", "#{agentName,jdbcType=VARCHAR}");
        }
        
        if (record.getAgentStaffId() != null) {
            sql.VALUES("agent_staff_id", "#{agentStaffId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentStaffName() != null) {
            sql.VALUES("agent_staff_name", "#{agentStaffName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerNo() != null) {
            sql.VALUES("mer_no", "#{merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerName() != null) {
            sql.VALUES("mer_name", "#{merName,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderNo() != null) {
            sql.VALUES("order_no", "#{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderChildNo() != null) {
            sql.VALUES("order_child_no", "#{orderChildNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOilNo() != null) {
            sql.VALUES("oil_no", "#{oilNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAmount() != null) {
            sql.VALUES("amount", "#{amount,jdbcType=DECIMAL}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getFailRemark() != null) {
            sql.VALUES("fail_remark", "#{failRemark,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsGasOrderReceiptExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("apply_no");
        sql.SELECT("user_receipt_id");
        sql.SELECT("company_name");
        sql.SELECT("tax_no");
        sql.SELECT("contacts_phone");
        sql.SELECT("email");
        sql.SELECT("agent_id");
        sql.SELECT("agent_name");
        sql.SELECT("agent_staff_id");
        sql.SELECT("agent_staff_name");
        sql.SELECT("mer_no");
        sql.SELECT("mer_name");
        sql.SELECT("order_no");
        sql.SELECT("order_child_no");
        sql.SELECT("oil_no");
        sql.SELECT("amount");
        sql.SELECT("`status`");
        sql.SELECT("fail_remark");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_gas_order_receipt");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsGasOrderReceipt record = (BsGasOrderReceipt) parameter.get("record");
        BsGasOrderReceiptExample example = (BsGasOrderReceiptExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_gas_order_receipt");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getApplyNo() != null) {
            sql.SET("apply_no = #{record.applyNo,jdbcType=VARCHAR}");
        }
        
        if (record.getUserReceiptId() != null) {
            sql.SET("user_receipt_id = #{record.userReceiptId,jdbcType=BIGINT}");
        }
        
        if (record.getCompanyName() != null) {
            sql.SET("company_name = #{record.companyName,jdbcType=VARCHAR}");
        }
        
        if (record.getTaxNo() != null) {
            sql.SET("tax_no = #{record.taxNo,jdbcType=VARCHAR}");
        }
        
        if (record.getContactsPhone() != null) {
            sql.SET("contacts_phone = #{record.contactsPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getEmail() != null) {
            sql.SET("email = #{record.email,jdbcType=VARCHAR}");
        }
        
        if (record.getAgentId() != null) {
            sql.SET("agent_id = #{record.agentId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentName() != null) {
            sql.SET("agent_name = #{record.agentName,jdbcType=VARCHAR}");
        }
        
        if (record.getAgentStaffId() != null) {
            sql.SET("agent_staff_id = #{record.agentStaffId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentStaffName() != null) {
            sql.SET("agent_staff_name = #{record.agentStaffName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerNo() != null) {
            sql.SET("mer_no = #{record.merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerName() != null) {
            sql.SET("mer_name = #{record.merName,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderChildNo() != null) {
            sql.SET("order_child_no = #{record.orderChildNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOilNo() != null) {
            sql.SET("oil_no = #{record.oilNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAmount() != null) {
            sql.SET("amount = #{record.amount,jdbcType=DECIMAL}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getFailRemark() != null) {
            sql.SET("fail_remark = #{record.failRemark,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_gas_order_receipt");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("apply_no = #{record.applyNo,jdbcType=VARCHAR}");
        sql.SET("user_receipt_id = #{record.userReceiptId,jdbcType=BIGINT}");
        sql.SET("company_name = #{record.companyName,jdbcType=VARCHAR}");
        sql.SET("tax_no = #{record.taxNo,jdbcType=VARCHAR}");
        sql.SET("contacts_phone = #{record.contactsPhone,jdbcType=VARCHAR}");
        sql.SET("email = #{record.email,jdbcType=VARCHAR}");
        sql.SET("agent_id = #{record.agentId,jdbcType=BIGINT}");
        sql.SET("agent_name = #{record.agentName,jdbcType=VARCHAR}");
        sql.SET("agent_staff_id = #{record.agentStaffId,jdbcType=BIGINT}");
        sql.SET("agent_staff_name = #{record.agentStaffName,jdbcType=VARCHAR}");
        sql.SET("mer_no = #{record.merNo,jdbcType=VARCHAR}");
        sql.SET("mer_name = #{record.merName,jdbcType=VARCHAR}");
        sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        sql.SET("order_child_no = #{record.orderChildNo,jdbcType=VARCHAR}");
        sql.SET("oil_no = #{record.oilNo,jdbcType=VARCHAR}");
        sql.SET("amount = #{record.amount,jdbcType=DECIMAL}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("fail_remark = #{record.failRemark,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsGasOrderReceiptExample example = (BsGasOrderReceiptExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsGasOrderReceipt record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_gas_order_receipt");
        
        if (record.getApplyNo() != null) {
            sql.SET("apply_no = #{applyNo,jdbcType=VARCHAR}");
        }
        
        if (record.getUserReceiptId() != null) {
            sql.SET("user_receipt_id = #{userReceiptId,jdbcType=BIGINT}");
        }
        
        if (record.getCompanyName() != null) {
            sql.SET("company_name = #{companyName,jdbcType=VARCHAR}");
        }
        
        if (record.getTaxNo() != null) {
            sql.SET("tax_no = #{taxNo,jdbcType=VARCHAR}");
        }
        
        if (record.getContactsPhone() != null) {
            sql.SET("contacts_phone = #{contactsPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getEmail() != null) {
            sql.SET("email = #{email,jdbcType=VARCHAR}");
        }
        
        if (record.getAgentId() != null) {
            sql.SET("agent_id = #{agentId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentName() != null) {
            sql.SET("agent_name = #{agentName,jdbcType=VARCHAR}");
        }
        
        if (record.getAgentStaffId() != null) {
            sql.SET("agent_staff_id = #{agentStaffId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentStaffName() != null) {
            sql.SET("agent_staff_name = #{agentStaffName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerNo() != null) {
            sql.SET("mer_no = #{merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerName() != null) {
            sql.SET("mer_name = #{merName,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderChildNo() != null) {
            sql.SET("order_child_no = #{orderChildNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOilNo() != null) {
            sql.SET("oil_no = #{oilNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAmount() != null) {
            sql.SET("amount = #{amount,jdbcType=DECIMAL}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getFailRemark() != null) {
            sql.SET("fail_remark = #{failRemark,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsGasOrderReceiptExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}